import{s as Lt,n as Yt,o as St}from"../chunks/scheduler.db6b1edd.js";import{S as Pt,i as Nt,g as i,s as l,r as o,A as Wt,h as p,f as a,c as n,j as Jt,u as r,x as d,k as vt,y as It,a as s,v as m,d as f,t as h,w as c}from"../chunks/index.ef84021a.js";import{C as Q}from"../chunks/CodeBlock.786162a6.js";import{H as B,E as Zt}from"../chunks/EditOnGithub.f0365ffe.js";function Et($t){let g,F,X,V,u,H,$,wt='<a href="https://www.postgresql.org/docs/" rel="nofollow">PostgreSQL</a> is a powerful, open source object-relational database system. It is the most <a href="https://survey.stackoverflow.co/2024/technology#most-popular-technologies-database" rel="nofollow">popular</a> database by application developers for a few years running. <a href="https://github.com/timescale/pgai" rel="nofollow">pgai</a> is a PostgreSQL extension that allows you to easily ingest huggingface datasets into your PostgreSQL database.',R,w,G,M,Mt="You can easily run a docker container containing PostgreSQL with pgai.",z,b,A,y,bt="Then run the following command to install pgai into the database.",D,T,K,j,yt="You can then connect to the database using the <code>psql</code> command line tool in the container.",O,x,tt,k,Tt="or using your favorite PostgreSQL client using the following connection string: <code>postgresql://postgres:password@localhost:5432/postgres</code>",et,C,jt='Alternatively, you can install pgai into an existing PostgreSQL database. For instructions on how to install pgai into an existing PostgreSQL database, follow the instructions in the <a href="https://github.com/timescale/pgai" rel="nofollow">github repo</a>.',at,U,st,_,xt=`To load a dataset into PostgreSQL, you can use the <code>ai.load_dataset</code> function. This function will create a PostgreSQL table, and load the dataset from the Hugging Face Hub
in a streaming fashion.`,lt,J,nt,v,kt="You can now query the table using standard SQL.",it,L,pt,Y,Ct='Full documentation for the <code>ai.load_dataset</code> function can be found <a href="https://github.com/timescale/pgai/blob/main/docs/load_dataset_from_huggingface.md" rel="nofollow">here</a>.',ot,S,rt,P,Ut=`You can also import a subset of the dataset by specifying the <code>max_batches</code> parameter.
This is useful if the dataset is large and you want to experiment with a smaller subset.`,mt,N,ft,W,ht,I,_t=`You can also load a dataset into an existing table.
This is useful if you want more control over the data schema or want to predefine indexes and constraints on the data.`,ct,Z,dt,E,gt,q,ut;return u=new B({props:{title:"PostgreSQL",local:"postgresql",headingTag:"h1"}}),w=new B({props:{title:"Run PostgreSQL with pgai installed",local:"run-postgresql-with-pgai-installed",headingTag:"h2"}}),b=new Q({props:{code:"ZG9ja2VyJTIwcnVuJTIwLWQlMjAtLW5hbWUlMjBwZ2FpJTIwLXAlMjA1NDMyJTNBNTQzMiUyMCU1QyUwQS12JTIwcGctZGF0YSUzQSUyRmhvbWUlMkZwb3N0Z3JlcyUyRnBnZGF0YSUyRmRhdGElMjAlNUMlMEEtZSUyMFBPU1RHUkVTX1BBU1NXT1JEJTNEcGFzc3dvcmQlMjB0aW1lc2NhbGUlMkZ0aW1lc2NhbGVkYi1oYSUzQXBnMTc=",highlighted:`docker run -d --name pgai -p 5432:5432 \\
-v pg-data:/home/postgres/pgdata/data \\
-e POSTGRES_PASSWORD=password timescale/timescaledb-ha:pg17`,wrap:!1}}),T=new Q({props:{code:"ZG9ja2VyJTIwZXhlYyUyMC1pdCUyMHBnYWklMjBwc3FsJTIwLWMlMjAlMjJDUkVBVEUlMjBFWFRFTlNJT04lMjBhaSUyMENBU0NBREUlM0IlMjI=",highlighted:'docker <span class="hljs-built_in">exec</span> -it pgai psql -c <span class="hljs-string">&quot;CREATE EXTENSION ai CASCADE;&quot;</span>',wrap:!1}}),x=new Q({props:{code:"ZG9ja2VyJTIwZXhlYyUyMC1pdCUyMHBnYWklMjBwc3Fs",highlighted:'docker <span class="hljs-built_in">exec</span> -it pgai psql',wrap:!1}}),U=new B({props:{title:"Create a table from a dataset",local:"create-a-table-from-a-dataset",headingTag:"h2"}}),J=new Q({props:{code:"c2VsZWN0JTIwYWkubG9hZF9kYXRhc2V0KCdyYWpwdXJrYXIlMkZzcXVhZCclMkMlMjB0YWJsZV9uYW1lJTIwJTNEJTNFJTIwJ3NxdWFkJyklM0I=",highlighted:'<span class="hljs-keyword">select</span> ai.load_dataset(<span class="hljs-string">&#x27;rajpurkar/squad&#x27;</span>, table_name <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-string">&#x27;squad&#x27;</span>);',wrap:!1}}),L=new Q({props:{code:"c2VsZWN0JTIwKiUyMGZyb20lMjBzcXVhZCUyMGxpbWl0JTIwMTAlM0I=",highlighted:'<span class="hljs-keyword">select</span> <span class="hljs-operator">*</span> <span class="hljs-keyword">from</span> squad limit <span class="hljs-number">10</span>;',wrap:!1}}),S=new B({props:{title:"Import only a subset of the dataset",local:"import-only-a-subset-of-the-dataset",headingTag:"h2"}}),N=new Q({props:{code:"U0VMRUNUJTIwYWkubG9hZF9kYXRhc2V0KCdyYWpwdXJrYXIlMkZzcXVhZCclMkMlMjB0YWJsZV9uYW1lJTIwJTNEJTNFJTIwJ3NxdWFkJyUyQyUyMGJhdGNoX3NpemUlMjAlM0QlM0UlMjAxMDAlMkMlMjBtYXhfYmF0Y2hlcyUyMCUzRCUzRSUyMDEpJTNC",highlighted:'<span class="hljs-keyword">SELECT</span> ai.load_dataset(<span class="hljs-string">&#x27;rajpurkar/squad&#x27;</span>, table_name <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-string">&#x27;squad&#x27;</span>, batch_size <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-number">100</span>, max_batches <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-number">1</span>);',wrap:!1}}),W=new B({props:{title:"Load a dataset into an existing table",local:"load-a-dataset-into-an-existing-table",headingTag:"h2"}}),Z=new Q({props:{code:"c2VsZWN0JTIwYWkubG9hZF9kYXRhc2V0KCdyYWpwdXJrYXIlMkZzcXVhZCclMkMlMjB0YWJsZV9uYW1lJTIwJTNEJTNFJTIwJ3NxdWFkJyUyQyUyMGlmX3RhYmxlX2V4aXN0cyUyMCUzRCUzRSUyMCdhcHBlbmQnKSUzQg==",highlighted:'<span class="hljs-keyword">select</span> ai.load_dataset(<span class="hljs-string">&#x27;rajpurkar/squad&#x27;</span>, table_name <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-string">&#x27;squad&#x27;</span>, if_table_exists <span class="hljs-operator">=</span><span class="hljs-operator">&gt;</span> <span class="hljs-string">&#x27;append&#x27;</span>);',wrap:!1}}),E=new Zt({props:{source:"https://github.com/huggingface/dataset-viewer/blob/main/docs/source/postgresql.md"}}),{c(){g=i("meta"),F=l(),X=i("p"),V=l(),o(u.$$.fragment),H=l(),$=i("p"),$.innerHTML=wt,R=l(),o(w.$$.fragment),G=l(),M=i("p"),M.textContent=Mt,z=l(),o(b.$$.fragment),A=l(),y=i("p"),y.textContent=bt,D=l(),o(T.$$.fragment),K=l(),j=i("p"),j.innerHTML=yt,O=l(),o(x.$$.fragment),tt=l(),k=i("p"),k.innerHTML=Tt,et=l(),C=i("p"),C.innerHTML=jt,at=l(),o(U.$$.fragment),st=l(),_=i("p"),_.innerHTML=xt,lt=l(),o(J.$$.fragment),nt=l(),v=i("p"),v.textContent=kt,it=l(),o(L.$$.fragment),pt=l(),Y=i("p"),Y.innerHTML=Ct,ot=l(),o(S.$$.fragment),rt=l(),P=i("p"),P.innerHTML=Ut,mt=l(),o(N.$$.fragment),ft=l(),o(W.$$.fragment),ht=l(),I=i("p"),I.textContent=_t,ct=l(),o(Z.$$.fragment),dt=l(),o(E.$$.fragment),gt=l(),q=i("p"),this.h()},l(t){const e=Wt("svelte-u9bgzb",document.head);g=p(e,"META",{name:!0,content:!0}),e.forEach(a),F=n(t),X=p(t,"P",{}),Jt(X).forEach(a),V=n(t),r(u.$$.fragment,t),H=n(t),$=p(t,"P",{"data-svelte-h":!0}),d($)!=="svelte-11pfpre"&&($.innerHTML=wt),R=n(t),r(w.$$.fragment,t),G=n(t),M=p(t,"P",{"data-svelte-h":!0}),d(M)!=="svelte-v3acak"&&(M.textContent=Mt),z=n(t),r(b.$$.fragment,t),A=n(t),y=p(t,"P",{"data-svelte-h":!0}),d(y)!=="svelte-f4qfem"&&(y.textContent=bt),D=n(t),r(T.$$.fragment,t),K=n(t),j=p(t,"P",{"data-svelte-h":!0}),d(j)!=="svelte-1dz5f6f"&&(j.innerHTML=yt),O=n(t),r(x.$$.fragment,t),tt=n(t),k=p(t,"P",{"data-svelte-h":!0}),d(k)!=="svelte-1ho8pgc"&&(k.innerHTML=Tt),et=n(t),C=p(t,"P",{"data-svelte-h":!0}),d(C)!=="svelte-1gx5hrj"&&(C.innerHTML=jt),at=n(t),r(U.$$.fragment,t),st=n(t),_=p(t,"P",{"data-svelte-h":!0}),d(_)!=="svelte-104k2n4"&&(_.innerHTML=xt),lt=n(t),r(J.$$.fragment,t),nt=n(t),v=p(t,"P",{"data-svelte-h":!0}),d(v)!=="svelte-6rs9ov"&&(v.textContent=kt),it=n(t),r(L.$$.fragment,t),pt=n(t),Y=p(t,"P",{"data-svelte-h":!0}),d(Y)!=="svelte-nha3d7"&&(Y.innerHTML=Ct),ot=n(t),r(S.$$.fragment,t),rt=n(t),P=p(t,"P",{"data-svelte-h":!0}),d(P)!=="svelte-clqz10"&&(P.innerHTML=Ut),mt=n(t),r(N.$$.fragment,t),ft=n(t),r(W.$$.fragment,t),ht=n(t),I=p(t,"P",{"data-svelte-h":!0}),d(I)!=="svelte-11grycq"&&(I.textContent=_t),ct=n(t),r(Z.$$.fragment,t),dt=n(t),r(E.$$.fragment,t),gt=n(t),q=p(t,"P",{}),Jt(q).forEach(a),this.h()},h(){vt(g,"name","hf:doc:metadata"),vt(g,"content",Qt)},m(t,e){It(document.head,g),s(t,F,e),s(t,X,e),s(t,V,e),m(u,t,e),s(t,H,e),s(t,$,e),s(t,R,e),m(w,t,e),s(t,G,e),s(t,M,e),s(t,z,e),m(b,t,e),s(t,A,e),s(t,y,e),s(t,D,e),m(T,t,e),s(t,K,e),s(t,j,e),s(t,O,e),m(x,t,e),s(t,tt,e),s(t,k,e),s(t,et,e),s(t,C,e),s(t,at,e),m(U,t,e),s(t,st,e),s(t,_,e),s(t,lt,e),m(J,t,e),s(t,nt,e),s(t,v,e),s(t,it,e),m(L,t,e),s(t,pt,e),s(t,Y,e),s(t,ot,e),m(S,t,e),s(t,rt,e),s(t,P,e),s(t,mt,e),m(N,t,e),s(t,ft,e),m(W,t,e),s(t,ht,e),s(t,I,e),s(t,ct,e),m(Z,t,e),s(t,dt,e),m(E,t,e),s(t,gt,e),s(t,q,e),ut=!0},p:Yt,i(t){ut||(f(u.$$.fragment,t),f(w.$$.fragment,t),f(b.$$.fragment,t),f(T.$$.fragment,t),f(x.$$.fragment,t),f(U.$$.fragment,t),f(J.$$.fragment,t),f(L.$$.fragment,t),f(S.$$.fragment,t),f(N.$$.fragment,t),f(W.$$.fragment,t),f(Z.$$.fragment,t),f(E.$$.fragment,t),ut=!0)},o(t){h(u.$$.fragment,t),h(w.$$.fragment,t),h(b.$$.fragment,t),h(T.$$.fragment,t),h(x.$$.fragment,t),h(U.$$.fragment,t),h(J.$$.fragment,t),h(L.$$.fragment,t),h(S.$$.fragment,t),h(N.$$.fragment,t),h(W.$$.fragment,t),h(Z.$$.fragment,t),h(E.$$.fragment,t),ut=!1},d(t){t&&(a(F),a(X),a(V),a(H),a($),a(R),a(G),a(M),a(z),a(A),a(y),a(D),a(K),a(j),a(O),a(tt),a(k),a(et),a(C),a(at),a(st),a(_),a(lt),a(nt),a(v),a(it),a(pt),a(Y),a(ot),a(rt),a(P),a(mt),a(ft),a(ht),a(I),a(ct),a(dt),a(gt),a(q)),a(g),c(u,t),c(w,t),c(b,t),c(T,t),c(x,t),c(U,t),c(J,t),c(L,t),c(S,t),c(N,t),c(W,t),c(Z,t),c(E,t)}}}const Qt='{"title":"PostgreSQL","local":"postgresql","sections":[{"title":"Run PostgreSQL with pgai installed","local":"run-postgresql-with-pgai-installed","sections":[],"depth":2},{"title":"Create a table from a dataset","local":"create-a-table-from-a-dataset","sections":[],"depth":2},{"title":"Import only a subset of the dataset","local":"import-only-a-subset-of-the-dataset","sections":[],"depth":2},{"title":"Load a dataset into an existing table","local":"load-a-dataset-into-an-existing-table","sections":[],"depth":2}],"depth":1}';function Xt($t){return St(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ht extends Pt{constructor(g){super(),Nt(this,g,Xt,Et,Lt,{})}}export{Ht as component};
